<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Product;
use App\Models\Contact;
use App\Models\MultiUnit;
use App\Models\Contacttype;
use App\Models\Priceproduct;
use App\Models\Substocktransaction;
use Illuminate\Support\Facades\Log;

class ProductController extends Controller
{
    public function getProductAll(Request $request){
        $for_sale = isset($request->for_sale) ? (boolean)json_decode($request->for_sale) : 2;
        if (isset($request->contact_id)) {
            if($for_sale === 2){
                $data = Product::with('producttype','unit')->get();
            }else{
                $data = Product::with('producttype','unit')->where('for_sale', $for_sale)->get();
            }
            $customer = Contact::with('type')->where('id',$request->contact_id)->first();
            foreach ($data as $key => $value) {
                if (!empty($customer->type()->first())) {
                    $value['price'] = Priceproduct::where('product_id',$value->id)
                    ->where('name',$customer->type()->first()->name)->get();
                    
                   foreach ($value['price'] as $keyVal => $val) {
                       if($val->multi_unit_id == null){
                            $value->selling_price=$val->total;
                       }
                   }
                }
            }
        }else{
            if($for_sale === 2){
                $data = Product::with('producttype','price','unit')->get();
            }else{
                $data = Product::with('producttype','price','unit')->where('for_sale', $for_sale)->get();
            }
            foreach($data as &$d) 
            { 
               $d['multi_unit'] = MultiUnit::with('multi_unit')->whereIn('product_id', [$d->id])->get();
            }
        }

        $response = [
            'success'=>true,
            'product'=>$data,
        ];
        
        return response($response,200);
    }

    public function getProduct(Request $request){
        $for_sale = isset($request->for_sale) ? (boolean)json_decode($request->for_sale) : 2;
        if (isset($request->contact_id)) {
            if($for_sale === 2){
                $data = Product::with('producttype','unit')->where('qty','>','0')->orderBy('id', 'desc')->get();
            }else{
                $data = Product::with('producttype','unit')->where('qty','>','0')->where('for_sale',$for_sale)->orderBy('id', 'desc')->get();
            }
            $customer = Contact::with('type')->where('id',$request->contact_id)->first();
            foreach ($data as $key => $value) {
                if (!empty($customer->type()->first())) {
                    $value['price'] = Priceproduct::where('product_id',$value->id)
                    ->where('name',$customer->type()->first()->name)->get();
                    
                   foreach ($value['price'] as $keyVal => $val) {
                       if($val->multi_unit_id == null){
                            $value->selling_price=$val->total;
                       }
                   }
                }

                $value['multi_unit'] = MultiUnit::with('multi_unit')
                                               ->where('product_id', $value->id)
                                               ->get();
                $value['qty_jual'] = 0;
        
                // Concatenate codes from $data and $multi_unit
                $value['full_code'] = $value->code;
                foreach ($value['multi_unit'] as $multi_unit) {
                    if (isset($multi_unit->multi_code)) {
                        $value['full_code'] .= ', ' . $multi_unit->multi_code;
                    }
                }
            }
        }else{
            if($for_sale === 2){
                $data = Product::with('producttype','price','unit')->orderBy('id', 'desc')->get();
            }else{
                $data = Product::with('producttype','price','unit')->where('for_sale',$for_sale)->orderBy('id', 'desc')->get();
            }
            foreach($data as &$d) 
            { 
               $d['multi_unit'] = MultiUnit::with('multi_unit')->whereIn('product_id', [$d->id])->get();
               $d['qty_jual'] = 0;
        
                // Concatenate codes from $data and $multi_unit
                $d['full_code'] = $d->code;
                foreach ($d['multi_unit'] as $multi_unit) {
                    if (isset($multi_unit->multi_code)) {
                        $d['full_code'] .= ', ' . $multi_unit->multi_code;
                    }
                }
            }
        }

        $response = [
            'success'=>true,
            'product'=>$data,
        ];
        
        return response($response,200);
    }

    public function getProductLimit(Request $request){
        if (isset($request->contact_id)) {
            $data = Product::with('producttype','price','unit')->where('qty','>','0')->where('type', '=', 'limit')->get();
            $customer = Contact::with('type')->where('id',$request->contact_id)->first();
            foreach ($data as $key => $value) {
                if (!empty($customer->type()->first())) {
                    $price = Priceproduct::where('product_id',$value->id)
                    ->where('name',$customer->type()->first()->name)
                    ->first();
                    if (!empty($price)) {
                        $value->selling_price=$price->total;
                    }
                }
            }
        }else{

            $data = Product::with('producttype','price','unit')->where('type', '=', 'limit')->get();
            foreach($data as &$d) 
            { 
               $d['multi_unit'] = MultiUnit::with('multi_unit')->whereIn('product_id', [$d->id])->get();
            }
        }

        $response = [
            'success'=>true,
            'product'=>$data,
        ];
        
        return response($response,200);
    }

    public function getProductGoods(Request $request){
        $data = Product::with('producttype','price','unit')->where('category','<>','service')->get();
        foreach ($data as $product) {
            $product['multi_unit'] = MultiUnit::with('multi_unit')
                                               ->where('product_id', $product->id)
                                               ->get();
            $product['qty_jual'] = 0;
    
            // Concatenate codes from $data and $multi_unit
            $product['full_code'] = $product->code;
            foreach ($product['multi_unit'] as $multi_unit) {
                if (isset($multi_unit->multi_code)) {
                    $product['full_code'] .= ', ' . $multi_unit->multi_code;
                }
            }
        }
        if (isset($request->contact_id)) {
            $customer = Contact::with('type')->where('id',$request->contact_id)->first();
            foreach ($data as $key => $value) {
                if (!empty($customer->type()->first())) {
                    $price = Priceproduct::where('product_id',$value->id)
                    ->where('name',$customer->type()->first()->name)
                    ->first();
                    if (!empty($price)) {
                        $value->selling_price=$price->total;
                    }
                }
            }
        }

        $response = [
            'success'=>true,
            'product'=>$data,
        ];
        
        return response($response,200);
    }

    public function getProductService(Request $request){
        $data = Product::with('producttype','price','unit')->where('qty','>',0)->where('category','service')->get();
        if (isset($request->contact_id)) {
            $customer = Contact::with('type')->where('id',$request->contact_id)->first();
            foreach ($data as $key => $value) {
                if (!empty($customer->type()->first())) {
                    $price = Priceproduct::where('product_id',$value->id)
                    ->where('name',$customer->type()->first()->name)
                    ->first();
                    if (!empty($price)) {
                        $value->selling_price=$price->total;
                    }
                }
            }
        }

        $response = [
            'success'=>true,
            'product'=>$data,
        ];
        
        return response($response,200);
    }

    public function getProductDetail(Request $request){
        $data = Product::with('producttype','price','unit')->find($request->id);
        $data['multi_unit'] = MultiUnit::with('multi_unit')
                                       ->where('product_id', $data->id)
                                       ->get();

        $response = [
            'success'=>true,
            'product'=>$data,
        ];
        
        return response($response,200);
    }

    public function createProduct(Request $request){
        $request->validate([
            'name' =>'required',
            'unit'  =>'required',
            'purchase_price'  =>'nullable',
            'selling_price'  =>'required',
            'producttype'  =>'nullable',
            'code'  =>'nullable',
            'category'  =>'required',
            'profit_strategy'  =>'required',
            'profit_strategy_percent'  =>'nullable',
        ]);
        $for_sale = isset($request->for_sale) ? $request->for_sale : 1;
        $for_purchase = isset($request->for_purchase) ? $request->for_purchase : 1;
        $data = new Product;
        $data->code = $request->code;
        $data->name = $request->name;
        $data->product_image = $request->product_image;
        $data->display_rack = $request->display_rack;
        $data->qty = 0;
        $data->qty_minimum = $request->qty_minimum;
        $data->for_sale = $for_sale;
        $data->for_purchase = $for_purchase;
        $data->unit = $request->unit;
        $data->selling_price = $request->selling_price;
        $data->profit_strategy = $request->profit_strategy;
        if ($request->category=='service') {
            $data->qty = 1000000;
        }else {
            $data->producttype = $request->producttype;
            $data->purchase_price = $request->purchase_price;
        }
        if ($request->profit_strategy == 'persentase') {
            $data->profit_strategy_percent = $request->profit_strategy_percent;
        }else {
            $data->profit_strategy_percent = null;
        }
        $data->category = $request->category;

        $data->save();
        
        $response = [
            'success'=>true,
            'product'=>$data,
        ];
        
        return response($response,200);
    }

    public function createProductLimit(Request $request){
        $request->validate([
            'name' =>'required',
            'unit'  =>'required',
            'purchase_price'  =>'nullable',
            'selling_price'  =>'required',
            'producttype'  =>'nullable',
            'code'  =>'nullable',
            'category'  =>'required',
            'type'  =>'required',
        ]);
        $for_sale = isset($request->for_sale) ? $request->for_sale : 1;
        $data = new Product;
        $data->code = $request->code;
        $data->name = $request->name;
        $data->qty = 0;
        $data->type = $request->type;
        $data->for_sale = $for_sale;
        $data->unit = $request->unit;
        $data->selling_price = $request->selling_price;
        if ($request->category=='service') {
            $data->qty = 1000000;
        }else {
            $data->producttype = $request->producttype;
            $data->purchase_price = $request->purchase_price;
        }
        $data->category = $request->category;

        $data->save();
        
        $response = [
            'success'=>true,
            'product'=>$data,
        ];
        
        return response($response,200);
    }
    
    public function editProduct(Request $request){
        $request->validate([
            'name' =>'required',
            'unit'  =>'required',
            'purchase_price'  =>'nullable',
            'selling_price'  =>'required',
            'producttype'  =>'nullable',
            'code'  =>'nullable',
            'category'  =>'required',
            'profit_strategy'  =>'required',
            'profit_strategy_percent'  =>'nullable',
        ]);
        $for_sale = isset($request->for_sale) ? $request->for_sale : 1;
        $for_purchase = isset($request->for_purchase) ? $request->for_purchase : 1;
        $data = Product::find($request->id);
        $data->name = $request->name;
        $data->unit = $request->unit;
        $data->code = $request->code;
        $data->display_rack = $request->display_rack;
        $data->product_image = $request->product_image;
        $data->for_sale = $for_sale;
        $data->for_purchase = $for_purchase;
        $data->qty_minimum = $request->qty_minimum;
        $data->selling_price = $request->selling_price;
        $data->profit_strategy = $request->profit_strategy;
        if ($request->category=='service') {
            $data->qty = 100;
        }else {
            $data->producttype = $request->producttype;
            $data->purchase_price = $request->purchase_price;
        }
        if ($request->profit_strategy == 'persentase') {
            $data->profit_strategy_percent = $request->profit_strategy_percent;
        }else {
            $data->profit_strategy_percent = null;
        }
        $data->category = $request->category;

        $data->save();
        
        $response = [
            'success'=>true,
            'product'=>$data,
        ];
        
        return response($response,200);
    }

    public function deleteProduct(Request $request){
        // cek data harga spesial
        $price = Priceproduct::where('product_id',$request->id)->get();
        // cek data penjualan
        $stock = Substocktransaction::where('product_id',$request->id)
                                      ->with('stocktransaction')
                                      ->get()
                                      ->map(function ($item) {
                                        if($item->stocktransaction->pending === null && $item->stocktransaction->cashout_id){
                                            return 'BELI PRODUK';
                                        }
                                        else if($item->stocktransaction->pending && $item->stocktransaction->cashout_id){
                                            return 'PESANAN PEMBELIAN';
                                        }
                                        else if($item->stocktransaction->pending === null && $item->stocktransaction->cashin_id){
                                            return 'JUAL PRODUK';
                                        }
                                        else if($item->stocktransaction->pending && $item->stocktransaction->cashin_id){
                                            return 'PESANAN PENJUALAN';
                                        }
                                        else if($item->stocktransaction->nonmoney === 'in'){
                                            return 'KOREKSI STOK - TAMBAHKAN';
                                        }
                                        else if($item->stocktransaction->nonmoney === 'out'){
                                            return 'KOREKSI STOK - KURANGI';
                                        }
                                      });

        if($price && count($stock) > 0){
            // $response = [
            //     'success'=> false,
            //     'message'=> "silahkan hapus harga spesial dan " . join(", ", json_decode($stock, true)) . " terkait produk ini terlebih dahulu",
            // ];
            
            // return response($response,400);

            $response = [
                'success'=> false,
                'message'=> "silahkan hapus " . join(", ", json_decode($stock, true)) . " terkait produk ini terlebih dahulu",
            ];
            
            return response($response,400);

            foreach ($price as $listPrice) {
                $listPrice->delete();
            }
        }
        else if(count($stock) > 0){
            $response = [
                'success'=> false,
                'message'=> "silahkan hapus " . join(", ", json_decode($stock, true)) . " terkait produk ini terlebih dahulu",
            ];
            
            return response($response,400);
        }else if($price){
            // $response = [
            //     'success'=> false,
            //     'message'=> "silahkan hapus harga spesial terkait produk ini terlebih dahulu",
            // ];
            
            // return response($response,400);
            foreach ($price as $listPrice) {
                $listPrice->delete();
            }
        }

        $data = Product::find($request->id);
        $data->price()->delete();
        $data->delete();

        $multi = MultiUnit::where('product_id', $request->id)->get();
        if(count($multi) > 0){
            MultiUnit::where('product_id', $request->id)->delete();
        }
        
        $response = [
            'success'=>true,
            'product'=>$data,
        ];
        
        return response($response,200);
    }
}
